import java.util.Date;
import javax.swing.*;

ArrayList visitorTimestamps = new ArrayList();
ArrayList weatherTimestamps = new ArrayList();
ArrayList temperatures = new ArrayList();
ArrayList sunshine = new ArrayList();
ArrayList rainfall = new ArrayList();
long firstTimestamp;
long lastTimestamp;
int timestampRange;
int[] buckets;
int maxBucketFillLevel;
int type = 0;
boolean colour = true;
boolean invert = false;
boolean showWeather = true;
String folder;
float heatMapContrast = 2.25;
float textSize;
int graphWidth;
int offset;
PGraphics buffer;

void setup()
{
  size(800, 280);
  graphWidth = width;
  surface.setResizable(true);
  System.setProperty("apple.awt.fileDialogForDirectories", "true");
  JFileChooser dialog = new JFileChooser();
  dialog.setDialogTitle("Choose a data set for a device");
  dialog.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
  dialog.showOpenDialog(new JFrame());
  folder = dialog.getSelectedFile().getPath() + File.separatorChar;
  if (folder != null) parseVisitorData(folder);
  parseWeatherData();
  frameRate(10); // Slow everything down to stop the fan kicking off
}

void draw()
{
  background(0, 0, 0); // Black in HSB
  if ((buffer == null) ||(buffer.height != height) || (buffer.width != graphWidth)) {
    buffer = createGraphics(graphWidth, height);
  }
  buffer.beginDraw();
  buffer.colorMode(HSB, 360, 100, 100);
  buffer.background(0, 0, 0);
  textSize = float(graphWidth)/float(howManyDaysOfData()) * 0.14;
  if(textSize > 24) textSize = 24;
  buffer.textSize(textSize);
  if (type==0) drawLinearHeatMap();
  if (type==1) drawClockHeatMaps();
  if (type==2) drawLineGraph();
  if (type==3) drawCloudGraph();
  drawWeatherGraph();
  if (invert) buffer.filter(INVERT);
  buffer.endDraw();
  translate(offset, 0);
  image(buffer, 0, 0);
}

void keyPressed()
{
  if (key == 's') {
    // Fixes wierd bug in PGraphics that doesn't allow it to be saved (if it's big !)
    PImage saver = createImage(buffer.width,buffer.height,RGB);
    saver.pixels = buffer.pixels;
    saver.save(folder + getGraphTypeName() + ".png");
  }
  if (key == 'd') dumpRawData(folder);
  if (key == 'c') colour = !colour;
  if (key == 'i') invert = !invert;
  if (key == 'w') showWeather = !showWeather;
  if (keyCode == LEFT) graphWidth-=50;
  if (keyCode == RIGHT) graphWidth+=50;
  if (keyCode == TAB) type++;
  if (type>3) type = 0;
  if (key == '=') heatMapContrast += 0.25;
  if (key == '-') heatMapContrast -= 0.25;
  if (heatMapContrast < 1.0) heatMapContrast = 1.0;
}

void mouseDragged()
{
  offset += mouseX - pmouseX;
}